diff -c ../zip19i/fileio.c ./fileio.c
*** ../zip19i/fileio.c	Tue Nov  3 21:07:54 1992
--- ./fileio.c	Fri Sep 10 05:02:28 1993
***************
*** 811,816 ****
--- 971,1088 ----
  #  endif/* __TURBOC__  || __GO32__ */
  # endif /* MSDOS && !OS2 */
  
+ #ifdef __human68k__
+ #  define GetFileMode(name) (_dos_chmod((name), -1) & 0x3f)
+ #endif
+ 
+ #ifdef AMIGA
+  
+ /* What we have here is a mostly-generic routine using opend()/readd() and */
+ /* isshexp()/MATCH() to find all the files matching a multi-part filespec  */
+ /* using the portable pattern syntax.  It shouldn't take too much fiddling */
+ /* to make it usable for any other platform that has directory hierarchies */
+ /* but no shell-level pattern matching.  It works for patterns throughout  */
+ /* the pathname, such as "foo:*.?/source/x*.[ch]".                         */
+ 
+ /* whole is a pathname with wildcards, wildtail points somewhere in the  */
+ /* middle of it.  All wildcards to be expanded must come AFTER wildtail. */
+ 
+ local int wild_recurse(whole, wildtail) char *whole; char *wildtail;
+ {
+     dstrm *dir;
+     char *subwild, *name, *newwhole = NULL, *glue = NULL, plug = 0, plug2;
+     ush newlen, amatch = 0;
+     BPTR lok;
+     int e = ZE_MISS;
+ 
+     if (!isshexp(wildtail))
+         if (lok = Lock(whole, ACCESS_READ)) {       /* p exists? */
+             UnLock(lok);
+             return procname(whole);
+         } else
+             return ZE_MISS;                     /* woops, no wildcards! */
+ 
+     /* back up thru path components till existing dir found */
+     do {
+         name = wildtail + strlen(wildtail) - 1;
+         for (;;)
+             if (name-- <= wildtail || *name == '/') {
+                 subwild = name + 1;
+                 plug2 = *subwild;
+                 *subwild = 0;
+                 break;
+             }
+         if (glue)
+             *glue = plug;
+         glue = subwild;
+         plug = plug2;
+         dir = opend(whole);
+     } while (!dir && !disk_not_mounted && subwild > wildtail);
+     wildtail = subwild;                 /* skip past non-wild components */
+ 
+     if (subwild = strchr(wildtail + 1, '/')) {
+         /* this "+ 1" dodges the  ^^^ hole left by *glue == 0 */
+         *(subwild++) = 0;               /* wildtail = one component pattern */
+         newlen = strlen(whole) + strlen(subwild) + 32;
+     } else
+         newlen = strlen(whole) + 31;
+     if (!dir || !(newwhole = malloc(newlen))) {
+         if (glue)
+             *glue = plug;
+         e = dir ? ZE_MEM : ZE_MISS;
+         goto ohforgetit;
+     }
+     strcpy(newwhole, whole);
+     newlen = strlen(newwhole);
+     if (glue)
+         *glue = plug;                           /* repair damage to whole */
+     if (!isshexp(wildtail)) {
+         e = ZE_MISS;                            /* non-wild name not found */
+         goto ohforgetit;
+     }
+ 
+     while (name = readd(dir)) {
+         if (MATCH(wildtail, name)) {
+             strcpy(newwhole + newlen, name);
+             if (subwild) {
+                 name = newwhole + strlen(newwhole);
+                 *(name++) = '/';
+                 strcpy(name, subwild);
+                 e = wild_recurse(newwhole, name);
+             } else
+                 e = procname(newwhole);
+             newwhole[newlen] = 0;
+             if (e == ZE_OK)
+                 amatch = 1;
+             else if (e != ZE_MISS)
+                 break;
+         }
+     }
+ 
+   ohforgetit:
+     if (dir) closed(dir);
+     if (subwild) *--subwild = '/';
+     if (newwhole) free(newwhole);
+     if (e == ZE_MISS && amatch)
+         e = ZE_OK;
+     return e;
+ }
+ 
+ int wild(p) char *p;
+ {
+     char *use;
+ 
+     /* wild_recurse() can't handle colons in wildcard part: */
+     if (use = strchr(p, ':')) {
+         if (strchr(++use, ':'))
+             return ZE_PARMS;
+     } else
+         use = p;
+ 
+     return wild_recurse(p, use);
+ }
+ #endif /* AMIGA */
+                                           
  
  #ifdef VMS
  int wild(p)
***************
*** 826,831 ****
--- 1098,1111 ----
    if ((d = (dstrm *)malloc(sizeof(dstrm))) == NULL)
      return ZE_MEM;
    vms_wild(p, d);       /* pattern may be more than just directory name */
+ 
+   /*
+    * Save version specified by user to use in recursive drops into
+    * subdirectories.
+    */
+   strncpy(wild_version_part,d->nam.nam$l_ver,d->nam.nam$b_ver);
+   wild_version_part[d->nam.nam$b_ver] = 0;
+ 
    f = 0;
    while ((e = readd(d)) != NULL)        /* "dosmatch" is already built in */
      if (procname(e) == ZE_OK)
***************
*** 885,891 ****
  
  
  local int fqcmp(a, b)
! voidp *a, *b;           /* pointers to pointers to found entries */
  /* Used by qsort() to compare entries in the found list by name. */
  {
    return strcmp((*(struct flist far **)a)->name,
--- 1165,1171 ----
  
  
  local int fqcmp(a, b)
! const voidp *a, *b;           /* pointers to pointers to found entries */
  /* Used by qsort() to compare entries in the found list by name. */
  {
    return strcmp((*(struct flist far **)a)->name,
***************
*** 894,900 ****
  
  
  local int fqcmpz(a, b)
! voidp *a, *b;           /* pointers to pointers to found entries */
  /* Used by qsort() to compare entries in the found list by zname. */
  {
    return strcmp((*(struct flist far **)a)->zname,
--- 1174,1180 ----
  
  
  local int fqcmpz(a, b)
! const voidp *a, *b;           /* pointers to pointers to found entries */
  /* Used by qsort() to compare entries in the found list by zname. */
  {
    return strcmp((*(struct flist far **)a)->zname,
***************
*** 930,941 ****
  
    p = q = n;
    f = 0;
!   while ((c = *p++) != 0)
      if (c == '/')
      {
        *q++ = (char)c;
        f = 0;                            /* new component */
      }
      else if (c == '.')
        if (f < 9)
        {
--- 1210,1234 ----
  
    p = q = n;
    f = 0;
!   while ((c = (unsigned char)*p++) != 0)
      if (c == '/')
      {
        *q++ = (char)c;
        f = 0;                            /* new component */
      }
+ #ifdef __human68k__
+     else if (iskanji(c))
+     {
+       if (f == 7 || f == 11)
+         f++;
+       else if (*p != '\0' && f < 12 && f != 8)
+       {
+         *q++ = c;
+         *q++ = *p++;
+         f += 2;
+       }
+     }
+ #endif
      else if (c == '.')
        if (f < 9)
        {
***************
*** 981,987 ****
  }
  #endif /* VMS */
  
! local char *ex2in(x, isdir, pdosflag)
  char *x;                /* external file name */
  int isdir;              /* input: x is a directory */
  int *pdosflag;          /* output: force MSDOS file attributes? */
--- 1274,1280 ----
  }
  #endif /* VMS */
  
! char *ex2in(x, isdir, pdosflag)
  char *x;                /* external file name */
  int isdir;              /* input: x is a directory */
  int *pdosflag;          /* output: force MSDOS file attributes? */
***************
*** 999,1019 ****
  
    jfn = _gtjfn(x, (O_RDONLY));
    ablock[1] = (int) (fname - 1);
!   ablock[2] = jfn & 0777777;	/* jfn, no flags */
!   ablock[3] = 0111100000001;	/* DEV+DIR+NAME+TYPE, punctuate */
    if (!jsys(JFNS, ablock)) {
        _rljfn(jfn);
!       return NULL;		/* something bad happened */
    }
    _rljfn(jfn);
    if ((fp = (char *)malloc(strlen(fname) + 1)) == NULL) {
        return NULL;
    }
!   strcpy(fp, fname);		/* copy the file name here */
    x = fp;
  #endif /* TOPS20 */
  
! #ifdef OS2
    dosflag = dosify || IsFileSystemFAT(x);
    if (!dosify && use_longname_ea && (t = GetLongPathEA(x)) != NULL)
    {
--- 1292,1312 ----
  
    jfn = _gtjfn(x, (O_RDONLY));
    ablock[1] = (int) (fname - 1);
!   ablock[2] = jfn & 0777777;    /* jfn, no flags */
!   ablock[3] = 0111100000001;    /* DEV+DIR+NAME+TYPE, punctuate */
    if (!jsys(JFNS, ablock)) {
        _rljfn(jfn);
!       return NULL;              /* something bad happened */
    }
    _rljfn(jfn);
    if ((fp = (char *)malloc(strlen(fname) + 1)) == NULL) {
        return NULL;
    }
!   strcpy(fp, fname);            /* copy the file name here */
    x = fp;
  #endif /* TOPS20 */
  
! #if defined(OS2) || defined(WIN32)
    dosflag = dosify || IsFileSystemFAT(x);
    if (!dosify && use_longname_ea && (t = GetLongPathEA(x)) != NULL)
    {
***************
*** 1029,1035 ****
  #endif /* ?OS2 */
  
    /* Find starting point in name before doing malloc */
! #ifdef MSDOS                            /* msdos */
    t = *x && *(x + 1) == ':' ? x + 2 : x;
    while (*t == '/' || *t == '\\')
      t++;
--- 1322,1328 ----
  #endif /* ?OS2 */
  
    /* Find starting point in name before doing malloc */
! #if defined(MSDOS) || defined(__human68k__) /* msdos */
    t = *x && *(x + 1) == ':' ? x + 2 : x;
    while (*t == '/' || *t == '\\')
      t++;
***************
*** 1043,1055 ****
        t = x + 1;
      else
        t = n + 1;
! #  else /* !(VMS || TOPS20) */                      /* unix */
    for (t = x; *t == '/'; t++)
      ;
  #  endif /* ?(VMS || TOPS20) */
  #endif /* ?MSDOS */
  
    /* Make changes, if any, to the copied name (leave original intact) */
  #ifdef MSDOS
    for (n = t; *n; n++)
      if (*n == '\\')
--- 1336,1366 ----
        t = x + 1;
      else
        t = n + 1;
! #  else /* !(VMS || TOPS20) */
! #    ifdef AMIGA
!   if ((t = strrchr(x, ':')) != NULL)    /* reject ":" */
!     t++;
!   else
!     t = x;
!   {                                     /* reject "//" */
!     char *tt = t;
!     while (tt = strchr(tt, '/'))
!       while (*++tt == '/')
!         t = tt;
!   }
!   while (*t == '/')             /* reject leading "/" on what's left */
!     t++;
! #    else /* !AMIGA */                      /* unix */
    for (t = x; *t == '/'; t++)
      ;
+ #    endif /* ?AMIGA */
  #  endif /* ?(VMS || TOPS20) */
  #endif /* ?MSDOS */
  
    /* Make changes, if any, to the copied name (leave original intact) */
+ #ifdef __human68k__
+   _toslash(t);
+ #endif /* !__human68k__ */
  #ifdef MSDOS
    for (n = t; *n; n++)
      if (*n == '\\')
***************
*** 1131,1142 ****
  #endif /* VMS */
    }
  #else
!   isdir += 0;      /* avoid warning on unused variable */
  #endif /* ?(VMS || TOPS20) */
  
    if (dosify)
      msname(n);
! #if defined(MSDOS) && !defined(OS2)
    else
      strlwr(n);
  #endif
--- 1442,1453 ----
  #endif /* VMS */
    }
  #else
!   if (isdir == 42) return n;      /* avoid warning on unused variable */
  #endif /* ?(VMS || TOPS20) */
  
    if (dosify)
      msname(n);
! #if defined(MSDOS) && !defined(OS2) && !defined(WIN32)
    else
      strlwr(n);
  #endif
***************
*** 1179,1185 ****
    strupper(x);
  #endif /* ?(VMS || TOPS20) */
  
! #ifdef OS2
    if ( !IsFileNameValid(x) )
      ChangeNameForFAT(x);
  #endif /* !OS2 */
--- 1490,1496 ----
    strupper(x);
  #endif /* ?(VMS || TOPS20) */
  
! #if defined(OS2) || defined(WIN32)
    if ( !IsFileNameValid(x) )
      ChangeNameForFAT(x);
  #endif /* !OS2 */
***************
*** 1187,1195 ****
  }
  
  
! int exclude()
! /* Change from including to excluding names when procname() called.  Return
!    an error code in the ZE_ class. */
  {
    struct flist far *f;          /* steps through found linked list */
    extent j;                     /* index for s */
--- 1498,1506 ----
  }
  
  
! int check_dup()
! /* Sort the found list and remove duplicates.
!    Return an error code in the ZE_ class. */
  {
    struct flist far *f;          /* steps through found linked list */
    extent j;                     /* index for s */
***************
*** 1218,1232 ****
        }
      free((voidp *)s);
    }
-   exflag = 1;
    return ZE_OK;
  }
  
  
  local int newname(n, isdir)
  char *n;                /* name to add (or exclude) */
  int  isdir;             /* true for a directory */
! /* Add (or exclude) a name that is not in the zip file.  Return an error
     code in the ZE_ class. */
  {
    char *m;
--- 1529,1566 ----
        }
      free((voidp *)s);
    }
    return ZE_OK;
  }
  
+ int filter(name)
+   char *name;
+   /* Scan the -i and -x lists for matches to the given name.
+      Return true if the name must be included, false otherwise.
+      Give precedence to -x over -i.
+    */
+ {
+    int n;
+    int include = icount ? 0 : 1;
+ #ifdef MATCH_LASTNAME_ONLY
+    char *p = last(name);
+    if (*p) name = p;
+ #endif
+ 
+    if (pcount == 0) return 1;
+ 
+    for (n = 0; n < pcount; n++) {
+       if (MATCH(patterns[n].zname, name)) {
+          if (patterns[n].select == 'x') return 0;
+          include = 1;
+       }
+    }
+    return include;
+ }
  
  local int newname(n, isdir)
  char *n;                /* name to add (or exclude) */
  int  isdir;             /* true for a directory */
! /* Add (or exclude) the name of an existing disk file.  Return an error
     code in the ZE_ class. */
  {
    char *m;
***************
*** 1238,1300 ****
       list of new names to do (or remove from that list). */
    if ((m = ex2in(n, isdir, &dosflag)) == NULL)
      return ZE_MEM;
    /* Discard directory names with zip -rj */
    if (*m == '\0') {
      if (pathput) error("empty name without -j");
      return ZE_OK;
    }
!   if ((z = zsearch(m)) != NULL)
!     if (exflag)
!     {
!       z->mark = 0;
        free((voidp *)m);
        if (verbose)
          fprintf(mesg, "zip diagnostic: excluding %s\n", z->name);
!     }
!     else
!     {
        free((voidp *)(z->name));
-       free((voidp *)(z->zname));
        if ((z->name = malloc(strlen(n) + 1 + PAD)) == NULL)
          return ZE_MEM;
        strcpy(z->name, n);
        z->zname = m;
!       z->mark = 1;
        z->dosflag = dosflag;
        if (verbose)
          fprintf(mesg, "zip diagnostic: including %s\n", z->name);
      }
!   else
!     if (exflag)
!     {
!       /* search list for name--if there, remove it */
!       for (f = found; f != NULL; f = f->nxt)
!         if (namecmp(n, f->name) == 0)
!         {
!           fexpel(f);
!           break;
!         }
!       free((voidp *)m);
      }
!     else
      {
!       /* allocate space and add to list */
!       if ((f = (struct flist far *)farmalloc(sizeof(struct flist))) == NULL ||
!           (f->name = malloc(strlen(n) + 1 + PAD)) == NULL)
!       {
!         if (f != NULL)
!           farfree((voidp far *)f);
!         return ZE_MEM;
!       }
!       strcpy(f->name, n);
!       f->zname = m;
!       f->dosflag = dosflag;
!       *fnxt = f;
!       f->lst = fnxt;
!       f->nxt = NULL;
!       fnxt = &f->nxt;
!       fcount++;
      }
    return ZE_OK;
  }
  
--- 1572,1657 ----
       list of new names to do (or remove from that list). */
    if ((m = ex2in(n, isdir, &dosflag)) == NULL)
      return ZE_MEM;
+ 
    /* Discard directory names with zip -rj */
    if (*m == '\0') {
+ #ifndef AMIGA
+ /* A null string is a legitimate external directory name in AmigaDOS; also,
+  * a command like "zip -r zipfile FOO:" produces an empty internal name.
+  */
      if (pathput) error("empty name without -j");
+ #endif
+     free((voidp *)m);
      return ZE_OK;
    }
!   if ((z = zsearch(m)) != NULL) {
!     z->mark = pcount ? filter(m) : 1;
!     if (z->mark == 0) {
        free((voidp *)m);
        if (verbose)
          fprintf(mesg, "zip diagnostic: excluding %s\n", z->name);
!     } else {
        free((voidp *)(z->name));
        if ((z->name = malloc(strlen(n) + 1 + PAD)) == NULL)
          return ZE_MEM;
        strcpy(z->name, n);
+ #ifdef FORCE_NEWNAME
+       free((voidp *)(z->zname));
        z->zname = m;
! #else
!       /* Better keep the old name. Useful when updating on MSDOS a zip file
!        * made on Unix.
!        */
!       free((voidp *)m);
! #endif
        z->dosflag = dosflag;
        if (verbose)
          fprintf(mesg, "zip diagnostic: including %s\n", z->name);
      }
!     if (n == label) {
!        label = z->name;
      }
!   } else if (pcount == 0 || filter(m)) {
! 
!     /* Check that we are not adding the zip file to itself. This
!      * catches cases like "zip -m foo ../dir/foo.zip".
!      */
!     struct stat statb;
!     if (zipstate == -1)
!        zipstate = strcmp(zipfile, "-") != 0 &&
!                    stat(zipfile, &zipstatb) == 0;
!     if (zipstate == 1 && (statb = zipstatb, stat(n, &statb) == 0
!       && zipstatb.st_mode  == statb.st_mode
!       && zipstatb.st_ino   == statb.st_ino
!       && zipstatb.st_dev   == statb.st_dev
!       && zipstatb.st_uid   == statb.st_uid
!       && zipstatb.st_gid   == statb.st_gid
!       && zipstatb.st_size  == statb.st_size
!       && zipstatb.st_mtime == statb.st_mtime
!       && zipstatb.st_ctime == statb.st_ctime))
!       /* Don't compare a_time since we are reading the file */
!          return ZE_OK;
! 
!     /* allocate space and add to list */
!     if ((f = (struct flist far *)farmalloc(sizeof(struct flist))) == NULL ||
!         (f->name = malloc(strlen(n) + 1 + PAD)) == NULL)
      {
!       if (f != NULL)
!         farfree((voidp far *)f);
!       return ZE_MEM;
!     }
!     strcpy(f->name, n);
!     f->zname = m;
!     f->dosflag = dosflag;
!     *fnxt = f;
!     f->lst = fnxt;
!     f->nxt = NULL;
!     fnxt = &f->nxt;
!     fcount++;
!     if (n == label) {
!       label = f->name;
      }
+   }
    return ZE_OK;
  }
  
***************
*** 1309,1315 ****
  #endif
    dstrm *d;             /* directory stream from opend() */
    char *e;              /* pointer to name from readd() */
-   struct flist far *f;  /* steps through found list */
    int m;                /* matched flag */
    char *p;              /* path for recursion */
    struct stat s;        /* result of stat() */
--- 1666,1671 ----
***************
*** 1322,1329 ****
        linkput ? lstat(n, &s) :
  #endif /* S_IFLNK */
        SSTAT(n, &s)
! #if defined(__TURBOC__) || defined(VMS)
!        /* Borland and VMS C bug: stat() succeeds on wild card names! */
        || isshexp(n)
  #endif
       )
--- 1678,1685 ----
        linkput ? lstat(n, &s) :
  #endif /* S_IFLNK */
        SSTAT(n, &s)
! #if defined(__TURBOC__) || defined(VMS) || defined(__WATCOMC__)
!        /* For these 3 compilers, stat() succeeds on wild card names! */
        || isshexp(n)
  #endif
       )
***************
*** 1331,1429 ****
      /* Not a file or directory--search for shell expression in zip file */
      p = ex2in(n, 0, (int *)NULL);       /* shouldn't affect matching chars */
      m = 1;
!     for (z = zfiles; z != NULL; z = z->nxt)
        if (MATCH(p, z->zname))
        {
!         z->mark = !exflag;
          if (verbose)
!           fprintf(mesg, "zip diagnostic: %scluding %s\n",
!                  exflag ? "ex" : "in", z->name);
          m = 0;
        }
-     /* If excluding, also search for expression in found list */
-     if (exflag)
-     {
-       for (f = found; f != NULL;)
-         if (MATCH(p, f->zname))
-         {
-           f = fexpel(f);
-           m = 0;
-         }
-         else
-           f = f->nxt;
      }
      free((voidp *)p);
!     if (m)
!       return ZE_MISS;           /* no match */
    }
-   else
-   {
-     /* Live name--use if file, recurse if directory */
  
  #ifdef MSDOS
!     for (p = n; *p; p++)          /* use / consistently */
!       if (*p == '\\')
!         *p = '/';
  #endif /* MSDOS */
!     if ((s.st_mode & S_IFDIR) == 0)
      {
!       /* add or remove name of file */
!         if ((m = newname(n, 0)) != ZE_OK)
            return m;
      } else {
!         /* recurse into directory */
!         if (recurse && (d = opend(n)) != NULL)
          {
! #if (defined(VMS) || defined(TOPS20))
!           if ((m = newname(n, 1)) != ZE_OK)
            {
!             closed(d);    /* want just to set warning error and continue */
!             return m;
!           }
!           while ((e = readd(d)) != NULL)
!             if ((m = procname(e)) != ZE_OK)     /* recurse on name */
!             {
!               closed(d);
!               return m;
!             }
! #else /* (VMS || TOPS20) */
!           if ((p = malloc(strlen(n)+2)) == NULL)
              return ZE_MEM;
!           if (strcmp(n, ".") == 0)
!             *p = 0;  /* avoid "./" prefix and do not create zip entry */
!           else
            {
!             strcpy(p, n);
!             a = p + strlen(p);
!             if (a[-1] != '/')
!               strcpy(a, "/");
!             if ((m = newname(p, 1)) != ZE_OK)
!               return m;
            }
!           while ((e = readd(d)) != NULL)
!             if (strcmp(e, ".") && strcmp(e, ".."))
!             {
!               if ((a = malloc(strlen(p) + strlen(e) + 1)) == NULL)
!               {
!                 free((voidp *)p);
!                 closed(d);
!                 return ZE_MEM;
!               }
!               strcat(strcpy(a, p), e);
!               if ((m = procname(a)) != ZE_OK)   /* recurse on name */
!               {
!                 free((voidp *)a);  free((voidp *)p);
!                 closed(d);
!                 return m;
!               }
!               free((voidp *)a);
!             }
!           free((voidp *)p);
! #endif /* ? (VMS || TOPS20) */
!           closed(d);
          }
        }
      }
    return ZE_OK;
  }
  
--- 1687,1785 ----
      /* Not a file or directory--search for shell expression in zip file */
      p = ex2in(n, 0, (int *)NULL);       /* shouldn't affect matching chars */
      m = 1;
!     for (z = zfiles; z != NULL; z = z->nxt) {
        if (MATCH(p, z->zname))
        {
!         z->mark = pcount ? filter(z->zname) : 1;
          if (verbose)
!             fprintf(mesg, "zip diagnostic: %scluding %s\n",
!                z->mark ? "in" : "ex", z->name);
          m = 0;
        }
      }
      free((voidp *)p);
!     return m ? ZE_MISS : ZE_OK;
    }
  
+   /* Live name--use if file, recurse if directory */
+ #ifdef __human68k__
+   _toslash(n);
+ #endif
  #ifdef MSDOS
!   for (p = n; *p; p++)          /* use / consistently */
!     if (*p == '\\')
!       *p = '/';
  #endif /* MSDOS */
!   if ((s.st_mode & S_IFDIR) == 0)
!   {
!     /* add or remove name of file */
!     if ((m = newname(n, 0)) != ZE_OK)
!       return m;
!   } else {
! #if defined(VMS) || defined(TOPS20)
!     if (dirnames && (m = newname(n, 1)) != ZE_OK) {
!       return m;
!     }
!     /* recurse into directory */
!     if (recurse && (d = opend(n)) != NULL)
      {
!       while ((e = readd(d)) != NULL) {
!         if ((m = procname(e)) != ZE_OK)     /* recurse on name */
!         {
!           closed(d);
            return m;
+         }
+       }
+       closed(d);
+     }
+ #else /* (VMS || TOPS20) */
+     /* Add trailing / to the directory name */
+     if ((p = malloc(strlen(n)+2)) == NULL)
+       return ZE_MEM;
+     if (strcmp(n, ".") == 0) {
+       *p = 0;  /* avoid "./" prefix and do not create zip entry */
      } else {
!       strcpy(p, n);
!       a = p + strlen(p);
! #ifdef AMIGA
!       if (*p && a[-1] != '/' && a[-1] != ':')
! #else
!       if (a[-1] != '/')
! #endif
!         strcpy(a, "/");
!       if (dirnames && (m = newname(p, 1)) != ZE_OK) {
!         free((voidp *)p);
!         return m;
!       }
!     }
!     /* recurse into directory */
!     if (recurse && (d = opend(n)) != NULL)
!     {
!       while ((e = readd(d)) != NULL) {
!         if (strcmp(e, ".") && strcmp(e, ".."))
          {
!           if ((a = malloc(strlen(p) + strlen(e) + 1)) == NULL)
            {
!             free((voidp *)p);
!             closed(d);
              return ZE_MEM;
!           }
!           strcat(strcpy(a, p), e);
!           if ((m = procname(a)) != ZE_OK)   /* recurse on name */
            {
!             if (m == ZE_MISS)
!               warn("name not matched: ", a);
!             else
!               err(m, a);
            }
!           free((voidp *)a);
          }
        }
+       free((voidp *)p);
+       closed(d);
      }
+ #endif /* ? (VMS || TOPS20) */
+   } /* (s.st_mode & S_IFDIR) == 0) */
    return ZE_OK;
  }
  
***************
*** 1540,1546 ****
--- 1896,1906 ----
    SetFileTime(f, d);
  #else /* !OS2 */
    struct tm t;          /* argument for mktime() or invlocal() */
+ #if defined(WIN32) || defined(sgi)
+   struct utimbuf u;     /* argument for utime() */
+ #else
    time_t u[2];          /* argument for utime() */
+ #endif
  #ifndef __GO32__
    extern time_t mktime OF((struct tm *));
  #endif
***************
*** 1552,1569 ****
    t.tm_mday = (int)(d >> 16) & 0x1f;
    t.tm_mon = ((int)(d >> 21) & 0xf) - 1;
    t.tm_year = ((int)(d >> 25) & 0x7f) + 80;
! #if defined(MSDOS) || defined(OS2) || defined(CRAY)
    /* mktime() is more reliable than invlocal() because the time range is
     * wider on MSDOS than on Unix; required for Cray because invlocal assumes
     * 32-bit ints
     */
    u[0] = u[1] = mktime(&t);
! #else
    u[0] = u[1] = invlocal(&t);
  #endif
  
    /* Set updated and accessed times of f */
    utime(f, u);
  #endif /* ?OS2 */
  #endif /* ?VMS */
  #endif /* ?__TURBOC__ */
--- 1912,1937 ----
    t.tm_mday = (int)(d >> 16) & 0x1f;
    t.tm_mon = ((int)(d >> 21) & 0xf) - 1;
    t.tm_year = ((int)(d >> 25) & 0x7f) + 80;
! #if defined(WIN32) || defined (sgi)
!   u.actime = u.modtime = mktime(&t);
! #else
! # if defined(MSDOS) || defined(OS2) || defined(CRAY)
    /* mktime() is more reliable than invlocal() because the time range is
     * wider on MSDOS than on Unix; required for Cray because invlocal assumes
     * 32-bit ints
     */
    u[0] = u[1] = mktime(&t);
! # else
    u[0] = u[1] = invlocal(&t);
+ # endif
  #endif
  
    /* Set updated and accessed times of f */
+ #if defined(WIN32) || defined(sgi)
+   utime(f, &u);
+ #else
    utime(f, u);
+ #endif
  #endif /* ?OS2 */
  #endif /* ?VMS */
  #endif /* ?__TURBOC__ */
***************
*** 1654,1667 ****
--- 2022,2049 ----
    char name[FNMAX];
    int len = strlen(f);
  
+   if (f == label) {
+     if (a != NULL)
+       *a = label_mode;
+     if (n != NULL)
+       *n = -2L; /* convention for a label name */
+     return label_time;  /* does not work for unknown reason */
+   }
    strcpy(name, f);
    if (name[len - 1] == '/')
      name[len - 1] = 0; 
    /* not all systems allow stat'ing a file with / appended */
  
    if (strcmp(f, "-") == 0) {
+ #if defined(AMIGA) && !defined(__SASC_60)
+   /* forge stat values for stdin since Amiga has no fstat() */
+     s.st_mode = (S_IREAD|S_IWRITE|S_IFREG); 
+     s.st_size = -1;
+     s.st_mtime = time(&s.st_mtime);
+ #else /* !AMIGA */
      if (fstat(fileno(stdin), &s) != 0)
        error("fstat(stdin)");
+ #endif /* ?AMIGA */
    } else if ((
  #ifdef S_IFLNK
               linkput ? lstat(name, &s) :
***************
*** 1672,1685 ****
                */
      return 0;
  
!   if (a != NULL)
! #if defined(MSDOS) || defined(OS2)
      *a = ((ulg)s.st_mode << 16) | (ulg)GetFileMode(name);
  #else
      *a = ((ulg)s.st_mode << 16) | !(s.st_mode & S_IWRITE);
  #endif
    if (n != NULL)
!     *n = (s.st_mode & S_IFREG) == 0 ? -1L : s.st_size;
  
  #ifdef OS2
    return GetFileTime(name);
--- 2054,2071 ----
                */
      return 0;
  
!   if (a != NULL) {
! #if defined(MSDOS) || defined(OS2) || defined(__human68k__)
      *a = ((ulg)s.st_mode << 16) | (ulg)GetFileMode(name);
  #else
      *a = ((ulg)s.st_mode << 16) | !(s.st_mode & S_IWRITE);
+     if ((s.st_mode & S_IFDIR) != 0) {
+       *a |= MSDOS_DIR_ATTR;
+     }
  #endif
+   }
    if (n != NULL)
!     *n = (s.st_mode & S_IFMT) != S_IFREG ? -1L : s.st_size;
  
  #ifdef OS2
    return GetFileTime(name);
***************
*** 1690,1706 ****
  #    ifdef ATARI_ST
         return s.st_mtime; /* Turbo C doesn't use UNIX times */
  #    else
!        return unix2dostime(&s.st_mtime);
  #    endif
  #  endif /* ?VMS */
  #endif /* ?OS2 */
  }
  
  #ifdef TOPS20
! #  include <monsym.h>	/* Get amazing monsym() macro */
! #  define	_FBBYV	monsym(".FBBYV")
! #  define	  FBBSZ_S	-24	/* Obsolete, replace by FLDGET! */
! #  define	  FBBSZ_M	077	/* ditto */
  
  extern int _gtjfn(), _rljfn(), _gtfdb(), stat();
  
--- 2076,2096 ----
  #    ifdef ATARI_ST
         return s.st_mtime; /* Turbo C doesn't use UNIX times */
  #    else
! #      ifdef WIN32
!          return GetTheFileTime(name);
! #      else
!          return unix2dostime((statime*)&s.st_mtime);
! #      endif /* WIN32 */
  #    endif
  #  endif /* ?VMS */
  #endif /* ?OS2 */
  }
  
  #ifdef TOPS20
! #  include <monsym.h>   /* Get amazing monsym() macro */
! #  define       _FBBYV  monsym(".FBBYV")
! #  define         FBBSZ_S       -24     /* Obsolete, replace by FLDGET! */
! #  define         FBBSZ_M       077     /* ditto */
  
  extern int _gtjfn(), _rljfn(), _gtfdb(), stat();
  
***************
*** 1713,1719 ****
    translate_eol = 0;
    jfn = _gtjfn(z->name, O_RDONLY);
    z->att = (((_gtfdb (jfn, _FBBYV) << FBBSZ_S) & FBBSZ_M) != 8) ?
! 	   ASCII :BINARY;
    _rljfn(jfn);
    return 0;
  }
--- 2103,2109 ----
    translate_eol = 0;
    jfn = _gtjfn(z->name, O_RDONLY);
    z->att = (((_gtfdb (jfn, _FBBYV) << FBBSZ_S) & FBBSZ_M) != 8) ?
!            ASCII :BINARY;
    _rljfn(jfn);
    return 0;
  }
***************
*** 1724,1730 ****
    struct zlist *z;
    /* create extra field and change z->att if desired */
  {
!   return 0;
  }
  # endif /* !OS2 && !VMS */
  #endif /* TOPS20 */
--- 2114,2120 ----
    struct zlist *z;
    /* create extra field and change z->att if desired */
  {
!   return (int)(z-z);
  }
  # endif /* !OS2 && !VMS */
  #endif /* TOPS20 */
